/*
 * StackBar
 * (c) Ronny Schoebel, 2001
 * $Id: StackBar.h,v 1.9 2001/07/30 13:23:22 risci Exp $
 *
 * This software is Freeware.
 * Please see the documentation for the license.
 */

#ifndef _STACK_BAR_H
#define _STACK_BAR_H

#include <View.h>
#include <List.h>
#include "StackPage.h"

class StackBar : public BView
{
public:
							StackBar( BRect frame, const char* pzName,
								uint32 nResizingMode = B_FOLLOW_LEFT |
								B_FOLLOW_TOP_BOTTOM,
								uint32 nFlags = B_FULL_UPDATE_ON_RESIZE |
								B_WILL_DRAW | B_FRAME_EVENTS |
								B_NAVIGABLE_JUMP | B_NAVIGABLE,
								border_style nStyle = B_FANCY_BORDER );
							StackBar( BMessage* pData );
	virtual 				~StackBar();
	static	BArchivable*	Instantiate( BMessage* pData );
	virtual	status_t		Archive( BMessage* pArchive, bool bDeep = true ) const;
	
	virtual	void			AddPage( BView* pTargetView, StackPage* pPage );
	virtual	StackPage*		RemovePage( int32 nPage );
	
	virtual	void			Select( int32 nPage );
			int32			Selection() const;
			
	virtual	void			SetPageHeight( float nHeight );
			float			PageHeight() const;
	virtual	StackPage*		PageAt( int32 nPage );
	virtual	BRect			PageFrame( int32 nPage );		
			BView*			ViewForPage( int32 nPage );
			BView*			ContainerView() const;
			float			BorderWidth() const;
			border_style	Border() const;
	virtual	void			SetBorder( border_style nStyle );
	virtual	void			Draw( BRect updateRect );
	virtual	void			DrawBorder( BRect frame, float nBorderWidth );
	virtual	void			DrawPages();
	virtual	void			AttachedToWindow();
	virtual	void			MouseDown( BPoint point );
	virtual void			MakeFocus( bool bFocused = true );
	virtual	void			SetFocusPage( int32 nPage );
			int32			FocusPage() const;
	virtual void			KeyDown( const char* pBytes, int32 nNumBytes );
	virtual	void			WindowActivated( bool bActive );
	virtual	void			FrameResized( float nNewWidth, float nNewHeight );
	virtual	void			GetPreferredSize( float* pnWidth, float* pnHeight );
	virtual	void			ResizeToPreferred();
	virtual	float			OptimalPageHeight( BFont *pFont );

protected:
	
	virtual	void			SetBorderWidthFromStyle( border_style nStyle );
	virtual	void			SetBorderWidth( float nWidth );
	virtual	void			AdjustContainerView();
								
				
private:

			
			int32			fnSelection;
			int32			fnFocusPage;
			float			fnPageHeight;
			BList			fPageList;
			BView*			fpContainerView;
			border_style	fnBorderStyle;
			float			fnBorderWidth;
};

#endif // _STACK_BAR_H
