/*
 * StackBar
 * (c) Ronny Schoebel, 2001
 * $Id: StackPage.h,v 1.4 2001/07/31 17:11:04 risci Exp $
 *
 * This software is Freeware.
 * Please see the documentation for the license.
 */

#ifndef _STACK_PAGE_H
#define _STACK_PAGE_H

#include <Archivable.h>
#include <View.h>
#include <String.h>


class StackPage : public BArchivable
{
public:

							StackPage( const char* pzLabel,
								BView* pTargetView = NULL );
							StackPage( BMessage* pData );
	virtual					~StackPage();
	static	BArchivable*	Instantiate( BMessage* pData );
	virtual	status_t		Archive( BMessage* pMessage, bool bDeep = true ) const;
	virtual	void			SetLabel( const char* pzLabel );
			const char*		Label() const;
	virtual void			SetView( BView* pTargetView );
			BView*			View() const;
	virtual void			Select( BView* pOwner );
	virtual void			Deselect();
			bool			IsSelected() const;
	virtual void			SetEnabled( bool bOn );
			bool			IsEnabled() const;
	virtual	void			MakeFocus( bool bFocused = true );
			bool			IsFocus() const;
	virtual	void			DrawPage( BView* pOwner, BRect frame );
	virtual	void			DrawLabel( BView* pOwner, BRect frame );
	virtual	void			DrawSelectionMark( BView* pOwner, BRect frame );
	virtual	void			DrawFocusMark( BView* pOwner, BRect frame );
	
private:

			BPoint			LabelPosition( BView* pOwner, BRect frame, BRect* pLabelFrame );
			BView*			fpTargetView;
			bool			fbSelected;
			bool			fbEnabled;
			bool			fbFocus;
			BString			fLabel;
	
};

#endif // _STACK_PAGE_H
